package de.hft.geotracker

import android.content.Intent
import android.os.Bundle
import androidx.fragment.app.Fragment
import android.widget.TextView
import androidx.appcompat.app.AppCompatActivity
import kotlinx.coroutines.CoroutineScope
import kotlinx.coroutines.Dispatchers
import kotlinx.coroutines.launch
import kotlinx.coroutines.withContext
import okhttp3.Authenticator
import okhttp3.OkHttpClient
import retrofit2.Call
import retrofit2.Callback
import retrofit2.Response
import retrofit2.Retrofit
import retrofit2.converter.gson.GsonConverterFactory
import retrofit2.http.Header
import retrofit2.http.Headers
import java.net.HttpRetryException

/**
 * A simple [Fragment] subclass.
 */
class Login  : AppCompatActivity() {
    lateinit var login : TextView
    lateinit var reg : TextView
    lateinit var service : GeofenceService
    lateinit var token : JWToken
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_login)

        val retrofit = Retrofit.Builder()
            .baseUrl("http://localhost:5000")
            .addConverterFactory(GsonConverterFactory.create())
            .build()
        service = retrofit.create(GeofenceService::class.java)

        login = findViewById(R.id.button_create_account)
        login.setOnClickListener {
            login()
        }
        reg = findViewById(R.id.button_register)
        reg.setOnClickListener {
            register()
        }
    }

    private fun register() {
        val intent = Intent(this, Register::class.java)
        startActivity(intent)
    }

    private fun login() {
        var call= service.login("wito","tobias")

        call.enqueue(object : Callback<Headers> {
            override fun onResponse(call: Call<Headers>?, response: Response<Headers>?) {
                if(response != null && response.isSuccessful) {

                    var headers = response.headers()
                    var authentication = headers.get("Authorization")

                    token = JWToken(authentication)
                    println("Erfolg")
                } else {
                    println("Fehler1")
                }
            }

            override fun onFailure(call: Call<Headers>?, t: Throwable?) {
                println("Fehler2 ${t.toString()}")
            }

        })
//        var token = call.execute().body()
//        val intent = Intent(this, MainActivity::class.java)
//        startActivity(intent)
    }
}
