package de.hft.geotime.user;

import com.fasterxml.jackson.annotation.JsonIgnore;
import de.hft.geotime.role.Role;
import de.hft.geotime.timetrackaccount.TimetrackAccount;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.persistence.*;
import java.util.List;

@Data
@NoArgsConstructor
@AllArgsConstructor
@Entity
public class TimetrackUser {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private long id;

    @Column(unique = true)
    private String username;

    @JsonIgnore
    private String password;

    private String firstname;

    private String lastname;

    @OneToOne
    private Role role;

    @OneToMany(fetch = FetchType.LAZY)
    private List<TimetrackAccount> accounts;

}
